################################################################################
# Licensed Materials - Property of IBM Copyright IBM Corporation 2012. All Rights Reserved.
# U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP
# Schedule Contract with IBM Corp.
################################################################################

################################################################################
# Class Definition                                                             #
################################################################################
module DevopsDeploymentLib
  
  # A class pretends (mock) to help deploy and monitor the creation of 
  # IWD Virtual System Pattern instances.
  class MockVirtualSystemDeploymentManager
    
      # See VirtualSystemDeploymentManager#initialize
      def initialize(root_server_uri=nil, user_name=nil, password=nil, conf={})
        return nil
      end

      # See VirtualSystemDeploymentManager#deploy
      def deploy(application_descriptor, environment)
        return {"virtual_machines" => {0 => {"nics" => {0 => {"ip_address"=>"0.0.0.0"}}}}}
      end
      
      # See VirtualSystemDeploymentManager#redeploy
      def redeploy(deployment_descriptor)
        return {"virtual_machines" => {0 => {"nics" => {0 => {"ip_address"=>"0.0.0.0"}}}}}
      end
      
      # See VirtualSystemDeploymentManager#get_deployment_file
      def get_deployment_file(application_descriptor, environment)
        deployment_file = Hash.new()
        deployment_file["content"] = {"virtual_machines" => {0 => {"nics" => {0 => {"ip_address"=>"0.0.0.0"}}}}}
      	return deployment_file
      end
      
      # See VirtualSystemDeploymentManager#create_deployment_file
      def create_deployment_file(application_descriptor, environment)
        deployment_file = get_deployment_file(application_descriptor, environment)
        # Tempfile class handles temp location on Linux vs. Windows
        tempfile = Tempfile.new("deploy.json")
        tempfile.write(deployment_file["content"])
        tempfile.close
        deployment_file["path"] = tempfile.path
        deployment_file["basename"] = File.basename(tempfile.path)       
        return deployment_file
      end
      
      # See VirtualSystemDeploymentManager#set_ssl_verify_mode
      def set_ssl_verify_mode(mode)
        return nil
      end
    
  end # end VirtualSystemDeploymentManager class
end #DevopsDeploymentLib
