require 'weaver/core/operating_system'

module Weaver
  module Core
    module Os
      # @see OperatingSystem
      class OsType

        # Hash for recognizing an Operating System, such as
        #  { :type => :linux, :flavor => :fedora, name => "Fedora", :regex => /fedora *(?<version>[0-9\.]*)/i, :valid_versions => [] }
        attr_accessor :os_info
        
        # * +os_handler+ an OperatingSystemHandler
        def initialize(os_handler)
          @os_handler = os_handler
        end

        def os(os_type, &block)
          @os_type = os_type
          self.instance_eval(&block)
        end

        def flavor(args)
          os_info = Hash.new
          os_info[:type] = @os_type
          os_info[:flavor] = args[:id]
          os_info[:name] = args[:name]
          os_info[:regex] = args[:regex]
          os_info[:valid_versions] = args[:valid_versions]
          @os_handler.known_oses[os_info[:flavor]] = os_info
        end

      end
    end
  end
end