require 'weaver/core/logging'

module Weaver
  module Dsl
    # \Weaver::Dsl::Requires provides parsing of +requirement+ and functions to create the different requirement types.
    #
    # All types are loaded using {TypeHandlerRegistry}.
    #
    module Requires
      # Abstract base class for Weaver Requirement types.
      class TypeHandler
        include Weaver::Core

        # Defines which types it can handle (can be 1..n). A type is a Symbol that is used 
        # in the Weaver DSL.
        attr_reader :handles
        
        
        def initialize(types = [])
          @handles = types
        end

        def handle(parent, args)
          @@logger.debug "#{self.to_s} #{parent} #{args}"
        end

      end
    end
    
  end
end