require 'weaver/coordination/logging'
require 'weaver/coordination/system'
require 'weaver/coordination/coordinated_transaction_manager'
require 'weaver/coordination/zk_shared_memory'

module Weaver
  module Coordination
    
    module CoordinationMixin
      include Weaver::Coordination::Logging
      
      def join_coordination ()
        # TODO excpetion if no transaction exists
        plan.transaction.write_data(status_path, Weaver::Coordination::CONFIG_STATUS::UNKNOWN)
      end # def join
      
      def start_coordinated_action ()
        plan.transaction.write_data(status_path, Weaver::Coordination::CONFIG_STATUS::CONFIGURING)
      end # def start
      
      def complete_coordinated_action ()
        plan.transaction.write_data(status_path, Weaver::Coordination::CONFIG_STATUS::CONFIGURED)
      end # def start

      def abort_coordinated_action ()
        plan.transaction.write_data(status_path, Weaver::Coordination::CONFIG_STATUS::FAILED)
      end # def start
      
      protected

      WEAVER_TX_BASE = "weaver_coordinated_transactions"
      
      def transaction_path
        return Weaver::Coordination::CoordinatedTransactionManager.instance.transaction_path(plan.transaction.id)
      end # def transaction_path
      
      def participant_path
        "participants/#{@id}"
      end # def participant_path
      
      def status_path 
      "#{participant_path}/#{Weaver::Coordination::CONFIG_STATUS_STR}"
      end # def status_path
      
      end # module CoordinationMixin
    
  end # module Coordination
end # module Weaver